#include "mtrand.h"

void MTRand_int32::gen_state() { // generate new state vector
    int i1, i397;
    unsigned long num;
    for (int i = 0; i < n; i++)
    {
        i1 = i + 1;
        i397 = i + 397;
        if(i1 >= n)
            i1 -= n;
        if(i397 >= n)
            i397 -=n;
        num = (state[i] & 0x80000000) | 
		(state[i1] & 0x7fffffff);
        num = state[i397] ^ (num >> 1) ^
		((num & 1) ? 0x9908b0df : 0);
        state[i] = num;
    }
    p = 0; // reset position
}

void MTRand_int32::seed(unsigned long s) {  // init by 32 bit seed
    state[0] = s;
    for (int i = 1; i < n; ++i) {
        state[i] = (unsigned long) (0x6c078965 * (state[i - 1] ^ (state[i - 1] >> 30))) + i;
    }
    p = n; // force gen_state() to be called for next random number
}